import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AlbLoadBalancerConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#description AlbLoadBalancer#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#folder_id AlbLoadBalancer#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#labels AlbLoadBalancer#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#name AlbLoadBalancer#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#network_id AlbLoadBalancer#network_id}
    */
    readonly networkId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#region_id AlbLoadBalancer#region_id}
    */
    readonly regionId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#security_group_ids AlbLoadBalancer#security_group_ids}
    */
    readonly securityGroupIds?: string[];
    /**
    * allocation_policy block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#allocation_policy AlbLoadBalancer#allocation_policy}
    */
    readonly allocationPolicy: AlbLoadBalancerAllocationPolicy;
    /**
    * listener block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#listener AlbLoadBalancer#listener}
    */
    readonly listener?: AlbLoadBalancerListener[] | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#timeouts AlbLoadBalancer#timeouts}
    */
    readonly timeouts?: AlbLoadBalancerTimeouts;
}
export interface AlbLoadBalancerAllocationPolicyLocation {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#disable_traffic AlbLoadBalancer#disable_traffic}
    */
    readonly disableTraffic?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#subnet_id AlbLoadBalancer#subnet_id}
    */
    readonly subnetId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#zone_id AlbLoadBalancer#zone_id}
    */
    readonly zoneId: string;
}
export declare function albLoadBalancerAllocationPolicyLocationToTerraform(struct?: AlbLoadBalancerAllocationPolicyLocation | cdktf.IResolvable): any;
export interface AlbLoadBalancerAllocationPolicy {
    /**
    * location block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#location AlbLoadBalancer#location}
    */
    readonly location: AlbLoadBalancerAllocationPolicyLocation[] | cdktf.IResolvable;
}
export declare function albLoadBalancerAllocationPolicyToTerraform(struct?: AlbLoadBalancerAllocationPolicyOutputReference | AlbLoadBalancerAllocationPolicy): any;
export declare class AlbLoadBalancerAllocationPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbLoadBalancerAllocationPolicy | undefined;
    set internalValue(value: AlbLoadBalancerAllocationPolicy | undefined);
    private _location?;
    get location(): AlbLoadBalancerAllocationPolicyLocation[] | cdktf.IResolvable;
    set location(value: AlbLoadBalancerAllocationPolicyLocation[] | cdktf.IResolvable);
    get locationInput(): cdktf.IResolvable | AlbLoadBalancerAllocationPolicyLocation[] | undefined;
}
export interface AlbLoadBalancerListenerEndpointAddressExternalIpv4Address {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#address AlbLoadBalancer#address}
    */
    readonly address?: string;
}
export declare function albLoadBalancerListenerEndpointAddressExternalIpv4AddressToTerraform(struct?: AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference | AlbLoadBalancerListenerEndpointAddressExternalIpv4Address): any;
export declare class AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbLoadBalancerListenerEndpointAddressExternalIpv4Address | undefined;
    set internalValue(value: AlbLoadBalancerListenerEndpointAddressExternalIpv4Address | undefined);
    private _address?;
    get address(): string;
    set address(value: string);
    resetAddress(): void;
    get addressInput(): string | undefined;
}
export interface AlbLoadBalancerListenerEndpointAddressExternalIpv6Address {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#address AlbLoadBalancer#address}
    */
    readonly address?: string;
}
export declare function albLoadBalancerListenerEndpointAddressExternalIpv6AddressToTerraform(struct?: AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference | AlbLoadBalancerListenerEndpointAddressExternalIpv6Address): any;
export declare class AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbLoadBalancerListenerEndpointAddressExternalIpv6Address | undefined;
    set internalValue(value: AlbLoadBalancerListenerEndpointAddressExternalIpv6Address | undefined);
    private _address?;
    get address(): string;
    set address(value: string);
    resetAddress(): void;
    get addressInput(): string | undefined;
}
export interface AlbLoadBalancerListenerEndpointAddressInternalIpv4Address {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#address AlbLoadBalancer#address}
    */
    readonly address?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#subnet_id AlbLoadBalancer#subnet_id}
    */
    readonly subnetId?: string;
}
export declare function albLoadBalancerListenerEndpointAddressInternalIpv4AddressToTerraform(struct?: AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference | AlbLoadBalancerListenerEndpointAddressInternalIpv4Address): any;
export declare class AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbLoadBalancerListenerEndpointAddressInternalIpv4Address | undefined;
    set internalValue(value: AlbLoadBalancerListenerEndpointAddressInternalIpv4Address | undefined);
    private _address?;
    get address(): string;
    set address(value: string);
    resetAddress(): void;
    get addressInput(): string | undefined;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
}
export interface AlbLoadBalancerListenerEndpointAddress {
    /**
    * external_ipv4_address block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#external_ipv4_address AlbLoadBalancer#external_ipv4_address}
    */
    readonly externalIpv4Address?: AlbLoadBalancerListenerEndpointAddressExternalIpv4Address;
    /**
    * external_ipv6_address block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#external_ipv6_address AlbLoadBalancer#external_ipv6_address}
    */
    readonly externalIpv6Address?: AlbLoadBalancerListenerEndpointAddressExternalIpv6Address;
    /**
    * internal_ipv4_address block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#internal_ipv4_address AlbLoadBalancer#internal_ipv4_address}
    */
    readonly internalIpv4Address?: AlbLoadBalancerListenerEndpointAddressInternalIpv4Address;
}
export declare function albLoadBalancerListenerEndpointAddressToTerraform(struct?: AlbLoadBalancerListenerEndpointAddress | cdktf.IResolvable): any;
export interface AlbLoadBalancerListenerEndpoint {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#ports AlbLoadBalancer#ports}
    */
    readonly ports: number[];
    /**
    * address block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#address AlbLoadBalancer#address}
    */
    readonly address: AlbLoadBalancerListenerEndpointAddress[] | cdktf.IResolvable;
}
export declare function albLoadBalancerListenerEndpointToTerraform(struct?: AlbLoadBalancerListenerEndpoint | cdktf.IResolvable): any;
export interface AlbLoadBalancerListenerHttpHandlerHttp2Options {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#max_concurrent_streams AlbLoadBalancer#max_concurrent_streams}
    */
    readonly maxConcurrentStreams?: number;
}
export declare function albLoadBalancerListenerHttpHandlerHttp2OptionsToTerraform(struct?: AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference | AlbLoadBalancerListenerHttpHandlerHttp2Options): any;
export declare class AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbLoadBalancerListenerHttpHandlerHttp2Options | undefined;
    set internalValue(value: AlbLoadBalancerListenerHttpHandlerHttp2Options | undefined);
    private _maxConcurrentStreams?;
    get maxConcurrentStreams(): number;
    set maxConcurrentStreams(value: number);
    resetMaxConcurrentStreams(): void;
    get maxConcurrentStreamsInput(): number | undefined;
}
export interface AlbLoadBalancerListenerHttpHandler {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#allow_http10 AlbLoadBalancer#allow_http10}
    */
    readonly allowHttp10?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http_router_id AlbLoadBalancer#http_router_id}
    */
    readonly httpRouterId?: string;
    /**
    * http2_options block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http2_options AlbLoadBalancer#http2_options}
    */
    readonly http2Options?: AlbLoadBalancerListenerHttpHandlerHttp2Options;
}
export declare function albLoadBalancerListenerHttpHandlerToTerraform(struct?: AlbLoadBalancerListenerHttpHandlerOutputReference | AlbLoadBalancerListenerHttpHandler): any;
export declare class AlbLoadBalancerListenerHttpHandlerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbLoadBalancerListenerHttpHandler | undefined;
    set internalValue(value: AlbLoadBalancerListenerHttpHandler | undefined);
    private _allowHttp10?;
    get allowHttp10(): boolean | cdktf.IResolvable;
    set allowHttp10(value: boolean | cdktf.IResolvable);
    resetAllowHttp10(): void;
    get allowHttp10Input(): boolean | cdktf.IResolvable | undefined;
    private _httpRouterId?;
    get httpRouterId(): string;
    set httpRouterId(value: string);
    resetHttpRouterId(): void;
    get httpRouterIdInput(): string | undefined;
    private _http2Options;
    get http2Options(): AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference;
    putHttp2Options(value: AlbLoadBalancerListenerHttpHandlerHttp2Options): void;
    resetHttp2Options(): void;
    get http2OptionsInput(): AlbLoadBalancerListenerHttpHandlerHttp2Options | undefined;
}
export interface AlbLoadBalancerListenerHttpRedirects {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http_to_https AlbLoadBalancer#http_to_https}
    */
    readonly httpToHttps?: boolean | cdktf.IResolvable;
}
export declare function albLoadBalancerListenerHttpRedirectsToTerraform(struct?: AlbLoadBalancerListenerHttpRedirectsOutputReference | AlbLoadBalancerListenerHttpRedirects): any;
export declare class AlbLoadBalancerListenerHttpRedirectsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbLoadBalancerListenerHttpRedirects | undefined;
    set internalValue(value: AlbLoadBalancerListenerHttpRedirects | undefined);
    private _httpToHttps?;
    get httpToHttps(): boolean | cdktf.IResolvable;
    set httpToHttps(value: boolean | cdktf.IResolvable);
    resetHttpToHttps(): void;
    get httpToHttpsInput(): boolean | cdktf.IResolvable | undefined;
}
export interface AlbLoadBalancerListenerHttp {
    /**
    * handler block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#handler AlbLoadBalancer#handler}
    */
    readonly handler?: AlbLoadBalancerListenerHttpHandler;
    /**
    * redirects block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#redirects AlbLoadBalancer#redirects}
    */
    readonly redirects?: AlbLoadBalancerListenerHttpRedirects;
}
export declare function albLoadBalancerListenerHttpToTerraform(struct?: AlbLoadBalancerListenerHttpOutputReference | AlbLoadBalancerListenerHttp): any;
export declare class AlbLoadBalancerListenerHttpOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbLoadBalancerListenerHttp | undefined;
    set internalValue(value: AlbLoadBalancerListenerHttp | undefined);
    private _handler;
    get handler(): AlbLoadBalancerListenerHttpHandlerOutputReference;
    putHandler(value: AlbLoadBalancerListenerHttpHandler): void;
    resetHandler(): void;
    get handlerInput(): AlbLoadBalancerListenerHttpHandler | undefined;
    private _redirects;
    get redirects(): AlbLoadBalancerListenerHttpRedirectsOutputReference;
    putRedirects(value: AlbLoadBalancerListenerHttpRedirects): void;
    resetRedirects(): void;
    get redirectsInput(): AlbLoadBalancerListenerHttpRedirects | undefined;
}
export interface AlbLoadBalancerListenerStreamHandler {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#backend_group_id AlbLoadBalancer#backend_group_id}
    */
    readonly backendGroupId?: string;
}
export declare function albLoadBalancerListenerStreamHandlerToTerraform(struct?: AlbLoadBalancerListenerStreamHandlerOutputReference | AlbLoadBalancerListenerStreamHandler): any;
export declare class AlbLoadBalancerListenerStreamHandlerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbLoadBalancerListenerStreamHandler | undefined;
    set internalValue(value: AlbLoadBalancerListenerStreamHandler | undefined);
    private _backendGroupId?;
    get backendGroupId(): string;
    set backendGroupId(value: string);
    resetBackendGroupId(): void;
    get backendGroupIdInput(): string | undefined;
}
export interface AlbLoadBalancerListenerStream {
    /**
    * handler block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#handler AlbLoadBalancer#handler}
    */
    readonly handler?: AlbLoadBalancerListenerStreamHandler;
}
export declare function albLoadBalancerListenerStreamToTerraform(struct?: AlbLoadBalancerListenerStreamOutputReference | AlbLoadBalancerListenerStream): any;
export declare class AlbLoadBalancerListenerStreamOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbLoadBalancerListenerStream | undefined;
    set internalValue(value: AlbLoadBalancerListenerStream | undefined);
    private _handler;
    get handler(): AlbLoadBalancerListenerStreamHandlerOutputReference;
    putHandler(value: AlbLoadBalancerListenerStreamHandler): void;
    resetHandler(): void;
    get handlerInput(): AlbLoadBalancerListenerStreamHandler | undefined;
}
export interface AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#max_concurrent_streams AlbLoadBalancer#max_concurrent_streams}
    */
    readonly maxConcurrentStreams?: number;
}
export declare function albLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsToTerraform(struct?: AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference | AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options): any;
export declare class AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options | undefined;
    set internalValue(value: AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options | undefined);
    private _maxConcurrentStreams?;
    get maxConcurrentStreams(): number;
    set maxConcurrentStreams(value: number);
    resetMaxConcurrentStreams(): void;
    get maxConcurrentStreamsInput(): number | undefined;
}
export interface AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#allow_http10 AlbLoadBalancer#allow_http10}
    */
    readonly allowHttp10?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http_router_id AlbLoadBalancer#http_router_id}
    */
    readonly httpRouterId?: string;
    /**
    * http2_options block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http2_options AlbLoadBalancer#http2_options}
    */
    readonly http2Options?: AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options;
}
export declare function albLoadBalancerListenerTlsDefaultHandlerHttpHandlerToTerraform(struct?: AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference | AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler): any;
export declare class AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler | undefined;
    set internalValue(value: AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler | undefined);
    private _allowHttp10?;
    get allowHttp10(): boolean | cdktf.IResolvable;
    set allowHttp10(value: boolean | cdktf.IResolvable);
    resetAllowHttp10(): void;
    get allowHttp10Input(): boolean | cdktf.IResolvable | undefined;
    private _httpRouterId?;
    get httpRouterId(): string;
    set httpRouterId(value: string);
    resetHttpRouterId(): void;
    get httpRouterIdInput(): string | undefined;
    private _http2Options;
    get http2Options(): AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference;
    putHttp2Options(value: AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options): void;
    resetHttp2Options(): void;
    get http2OptionsInput(): AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options | undefined;
}
export interface AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#backend_group_id AlbLoadBalancer#backend_group_id}
    */
    readonly backendGroupId?: string;
}
export declare function albLoadBalancerListenerTlsDefaultHandlerStreamHandlerToTerraform(struct?: AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference | AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler): any;
export declare class AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler | undefined;
    set internalValue(value: AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler | undefined);
    private _backendGroupId?;
    get backendGroupId(): string;
    set backendGroupId(value: string);
    resetBackendGroupId(): void;
    get backendGroupIdInput(): string | undefined;
}
export interface AlbLoadBalancerListenerTlsDefaultHandler {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#certificate_ids AlbLoadBalancer#certificate_ids}
    */
    readonly certificateIds: string[];
    /**
    * http_handler block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http_handler AlbLoadBalancer#http_handler}
    */
    readonly httpHandler?: AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler;
    /**
    * stream_handler block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#stream_handler AlbLoadBalancer#stream_handler}
    */
    readonly streamHandler?: AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler;
}
export declare function albLoadBalancerListenerTlsDefaultHandlerToTerraform(struct?: AlbLoadBalancerListenerTlsDefaultHandlerOutputReference | AlbLoadBalancerListenerTlsDefaultHandler): any;
export declare class AlbLoadBalancerListenerTlsDefaultHandlerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbLoadBalancerListenerTlsDefaultHandler | undefined;
    set internalValue(value: AlbLoadBalancerListenerTlsDefaultHandler | undefined);
    private _certificateIds?;
    get certificateIds(): string[];
    set certificateIds(value: string[]);
    get certificateIdsInput(): string[] | undefined;
    private _httpHandler;
    get httpHandler(): AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference;
    putHttpHandler(value: AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler): void;
    resetHttpHandler(): void;
    get httpHandlerInput(): AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler | undefined;
    private _streamHandler;
    get streamHandler(): AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference;
    putStreamHandler(value: AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler): void;
    resetStreamHandler(): void;
    get streamHandlerInput(): AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler | undefined;
}
export interface AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#max_concurrent_streams AlbLoadBalancer#max_concurrent_streams}
    */
    readonly maxConcurrentStreams?: number;
}
export declare function albLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsToTerraform(struct?: AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference | AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options): any;
export declare class AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options | undefined;
    set internalValue(value: AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options | undefined);
    private _maxConcurrentStreams?;
    get maxConcurrentStreams(): number;
    set maxConcurrentStreams(value: number);
    resetMaxConcurrentStreams(): void;
    get maxConcurrentStreamsInput(): number | undefined;
}
export interface AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#allow_http10 AlbLoadBalancer#allow_http10}
    */
    readonly allowHttp10?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http_router_id AlbLoadBalancer#http_router_id}
    */
    readonly httpRouterId?: string;
    /**
    * http2_options block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http2_options AlbLoadBalancer#http2_options}
    */
    readonly http2Options?: AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options;
}
export declare function albLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerToTerraform(struct?: AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference | AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler): any;
export declare class AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler | undefined;
    set internalValue(value: AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler | undefined);
    private _allowHttp10?;
    get allowHttp10(): boolean | cdktf.IResolvable;
    set allowHttp10(value: boolean | cdktf.IResolvable);
    resetAllowHttp10(): void;
    get allowHttp10Input(): boolean | cdktf.IResolvable | undefined;
    private _httpRouterId?;
    get httpRouterId(): string;
    set httpRouterId(value: string);
    resetHttpRouterId(): void;
    get httpRouterIdInput(): string | undefined;
    private _http2Options;
    get http2Options(): AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference;
    putHttp2Options(value: AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options): void;
    resetHttp2Options(): void;
    get http2OptionsInput(): AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options | undefined;
}
export interface AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#backend_group_id AlbLoadBalancer#backend_group_id}
    */
    readonly backendGroupId?: string;
}
export declare function albLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerToTerraform(struct?: AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference | AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler): any;
export declare class AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler | undefined;
    set internalValue(value: AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler | undefined);
    private _backendGroupId?;
    get backendGroupId(): string;
    set backendGroupId(value: string);
    resetBackendGroupId(): void;
    get backendGroupIdInput(): string | undefined;
}
export interface AlbLoadBalancerListenerTlsSniHandlerHandler {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#certificate_ids AlbLoadBalancer#certificate_ids}
    */
    readonly certificateIds: string[];
    /**
    * http_handler block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http_handler AlbLoadBalancer#http_handler}
    */
    readonly httpHandler?: AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler;
    /**
    * stream_handler block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#stream_handler AlbLoadBalancer#stream_handler}
    */
    readonly streamHandler?: AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler;
}
export declare function albLoadBalancerListenerTlsSniHandlerHandlerToTerraform(struct?: AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference | AlbLoadBalancerListenerTlsSniHandlerHandler): any;
export declare class AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbLoadBalancerListenerTlsSniHandlerHandler | undefined;
    set internalValue(value: AlbLoadBalancerListenerTlsSniHandlerHandler | undefined);
    private _certificateIds?;
    get certificateIds(): string[];
    set certificateIds(value: string[]);
    get certificateIdsInput(): string[] | undefined;
    private _httpHandler;
    get httpHandler(): AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference;
    putHttpHandler(value: AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler): void;
    resetHttpHandler(): void;
    get httpHandlerInput(): AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler | undefined;
    private _streamHandler;
    get streamHandler(): AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference;
    putStreamHandler(value: AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler): void;
    resetStreamHandler(): void;
    get streamHandlerInput(): AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler | undefined;
}
export interface AlbLoadBalancerListenerTlsSniHandler {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#name AlbLoadBalancer#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#server_names AlbLoadBalancer#server_names}
    */
    readonly serverNames: string[];
    /**
    * handler block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#handler AlbLoadBalancer#handler}
    */
    readonly handler: AlbLoadBalancerListenerTlsSniHandlerHandler;
}
export declare function albLoadBalancerListenerTlsSniHandlerToTerraform(struct?: AlbLoadBalancerListenerTlsSniHandler | cdktf.IResolvable): any;
export interface AlbLoadBalancerListenerTls {
    /**
    * default_handler block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#default_handler AlbLoadBalancer#default_handler}
    */
    readonly defaultHandler: AlbLoadBalancerListenerTlsDefaultHandler;
    /**
    * sni_handler block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#sni_handler AlbLoadBalancer#sni_handler}
    */
    readonly sniHandler?: AlbLoadBalancerListenerTlsSniHandler[] | cdktf.IResolvable;
}
export declare function albLoadBalancerListenerTlsToTerraform(struct?: AlbLoadBalancerListenerTlsOutputReference | AlbLoadBalancerListenerTls): any;
export declare class AlbLoadBalancerListenerTlsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbLoadBalancerListenerTls | undefined;
    set internalValue(value: AlbLoadBalancerListenerTls | undefined);
    private _defaultHandler;
    get defaultHandler(): AlbLoadBalancerListenerTlsDefaultHandlerOutputReference;
    putDefaultHandler(value: AlbLoadBalancerListenerTlsDefaultHandler): void;
    get defaultHandlerInput(): AlbLoadBalancerListenerTlsDefaultHandler | undefined;
    private _sniHandler?;
    get sniHandler(): AlbLoadBalancerListenerTlsSniHandler[] | cdktf.IResolvable;
    set sniHandler(value: AlbLoadBalancerListenerTlsSniHandler[] | cdktf.IResolvable);
    resetSniHandler(): void;
    get sniHandlerInput(): cdktf.IResolvable | AlbLoadBalancerListenerTlsSniHandler[] | undefined;
}
export interface AlbLoadBalancerListener {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#name AlbLoadBalancer#name}
    */
    readonly name: string;
    /**
    * endpoint block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#endpoint AlbLoadBalancer#endpoint}
    */
    readonly endpoint?: AlbLoadBalancerListenerEndpoint[] | cdktf.IResolvable;
    /**
    * http block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http AlbLoadBalancer#http}
    */
    readonly http?: AlbLoadBalancerListenerHttp;
    /**
    * stream block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#stream AlbLoadBalancer#stream}
    */
    readonly stream?: AlbLoadBalancerListenerStream;
    /**
    * tls block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#tls AlbLoadBalancer#tls}
    */
    readonly tls?: AlbLoadBalancerListenerTls;
}
export declare function albLoadBalancerListenerToTerraform(struct?: AlbLoadBalancerListener | cdktf.IResolvable): any;
export interface AlbLoadBalancerTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#create AlbLoadBalancer#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#delete AlbLoadBalancer#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#update AlbLoadBalancer#update}
    */
    readonly update?: string;
}
export declare function albLoadBalancerTimeoutsToTerraform(struct?: AlbLoadBalancerTimeoutsOutputReference | AlbLoadBalancerTimeouts | cdktf.IResolvable): any;
export declare class AlbLoadBalancerTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbLoadBalancerTimeouts | undefined;
    set internalValue(value: AlbLoadBalancerTimeouts | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer yandex_alb_load_balancer}
*/
export declare class AlbLoadBalancer extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_alb_load_balancer";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer yandex_alb_load_balancer} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AlbLoadBalancerConfig
    */
    constructor(scope: Construct, id: string, config: AlbLoadBalancerConfig);
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get id(): string;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    get logGroupId(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _networkId?;
    get networkId(): string;
    set networkId(value: string);
    get networkIdInput(): string | undefined;
    private _regionId?;
    get regionId(): string;
    set regionId(value: string);
    resetRegionId(): void;
    get regionIdInput(): string | undefined;
    private _securityGroupIds?;
    get securityGroupIds(): string[];
    set securityGroupIds(value: string[]);
    resetSecurityGroupIds(): void;
    get securityGroupIdsInput(): string[] | undefined;
    get status(): string;
    private _allocationPolicy;
    get allocationPolicy(): AlbLoadBalancerAllocationPolicyOutputReference;
    putAllocationPolicy(value: AlbLoadBalancerAllocationPolicy): void;
    get allocationPolicyInput(): AlbLoadBalancerAllocationPolicy | undefined;
    private _listener?;
    get listener(): AlbLoadBalancerListener[] | cdktf.IResolvable;
    set listener(value: AlbLoadBalancerListener[] | cdktf.IResolvable);
    resetListener(): void;
    get listenerInput(): cdktf.IResolvable | AlbLoadBalancerListener[] | undefined;
    private _timeouts;
    get timeouts(): AlbLoadBalancerTimeoutsOutputReference;
    putTimeouts(value: AlbLoadBalancerTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): AlbLoadBalancerTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
