import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AlbTargetGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#description AlbTargetGroup#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#folder_id AlbTargetGroup#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#labels AlbTargetGroup#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#name AlbTargetGroup#name}
    */
    readonly name?: string;
    /**
    * target block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#target AlbTargetGroup#target}
    */
    readonly target?: AlbTargetGroupTarget[] | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#timeouts AlbTargetGroup#timeouts}
    */
    readonly timeouts?: AlbTargetGroupTimeouts;
}
export interface AlbTargetGroupTarget {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#ip_address AlbTargetGroup#ip_address}
    */
    readonly ipAddress: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#private_ipv4_address AlbTargetGroup#private_ipv4_address}
    */
    readonly privateIpv4Address?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#subnet_id AlbTargetGroup#subnet_id}
    */
    readonly subnetId?: string;
}
export declare function albTargetGroupTargetToTerraform(struct?: AlbTargetGroupTarget | cdktf.IResolvable): any;
export interface AlbTargetGroupTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#create AlbTargetGroup#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#delete AlbTargetGroup#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#update AlbTargetGroup#update}
    */
    readonly update?: string;
}
export declare function albTargetGroupTimeoutsToTerraform(struct?: AlbTargetGroupTimeoutsOutputReference | AlbTargetGroupTimeouts | cdktf.IResolvable): any;
export declare class AlbTargetGroupTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbTargetGroupTimeouts | undefined;
    set internalValue(value: AlbTargetGroupTimeouts | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group yandex_alb_target_group}
*/
export declare class AlbTargetGroup extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_alb_target_group";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group yandex_alb_target_group} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AlbTargetGroupConfig = {}
    */
    constructor(scope: Construct, id: string, config?: AlbTargetGroupConfig);
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get id(): string;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _target?;
    get target(): AlbTargetGroupTarget[] | cdktf.IResolvable;
    set target(value: AlbTargetGroupTarget[] | cdktf.IResolvable);
    resetTarget(): void;
    get targetInput(): cdktf.IResolvable | AlbTargetGroupTarget[] | undefined;
    private _timeouts;
    get timeouts(): AlbTargetGroupTimeoutsOutputReference;
    putTimeouts(value: AlbTargetGroupTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): AlbTargetGroupTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
