import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface CdnOriginGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#name CdnOriginGroup#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#use_next CdnOriginGroup#use_next}
    */
    readonly useNext?: boolean | cdktf.IResolvable;
    /**
    * origin block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#origin CdnOriginGroup#origin}
    */
    readonly origin: CdnOriginGroupOrigin[] | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#timeouts CdnOriginGroup#timeouts}
    */
    readonly timeouts?: CdnOriginGroupTimeouts;
}
export interface CdnOriginGroupOrigin {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#backup CdnOriginGroup#backup}
    */
    readonly backup?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#enabled CdnOriginGroup#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#source CdnOriginGroup#source}
    */
    readonly source: string;
}
export declare function cdnOriginGroupOriginToTerraform(struct?: CdnOriginGroupOrigin | cdktf.IResolvable): any;
export interface CdnOriginGroupTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#create CdnOriginGroup#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#delete CdnOriginGroup#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#update CdnOriginGroup#update}
    */
    readonly update?: string;
}
export declare function cdnOriginGroupTimeoutsToTerraform(struct?: CdnOriginGroupTimeoutsOutputReference | CdnOriginGroupTimeouts | cdktf.IResolvable): any;
export declare class CdnOriginGroupTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): CdnOriginGroupTimeouts | undefined;
    set internalValue(value: CdnOriginGroupTimeouts | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group yandex_cdn_origin_group}
*/
export declare class CdnOriginGroup extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_cdn_origin_group";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group yandex_cdn_origin_group} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options CdnOriginGroupConfig
    */
    constructor(scope: Construct, id: string, config: CdnOriginGroupConfig);
    get folderId(): string;
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _useNext?;
    get useNext(): boolean | cdktf.IResolvable;
    set useNext(value: boolean | cdktf.IResolvable);
    resetUseNext(): void;
    get useNextInput(): boolean | cdktf.IResolvable | undefined;
    private _origin?;
    get origin(): CdnOriginGroupOrigin[] | cdktf.IResolvable;
    set origin(value: CdnOriginGroupOrigin[] | cdktf.IResolvable);
    get originInput(): cdktf.IResolvable | CdnOriginGroupOrigin[] | undefined;
    private _timeouts;
    get timeouts(): CdnOriginGroupTimeoutsOutputReference;
    putTimeouts(value: CdnOriginGroupTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): CdnOriginGroupTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
