import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexApiGatewayConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/api_gateway#api_gateway_id DataYandexApiGateway#api_gateway_id}
    */
    readonly apiGatewayId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/api_gateway#folder_id DataYandexApiGateway#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/api_gateway#name DataYandexApiGateway#name}
    */
    readonly name?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/api_gateway yandex_api_gateway}
*/
export declare class DataYandexApiGateway extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_api_gateway";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/api_gateway yandex_api_gateway} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexApiGatewayConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexApiGatewayConfig);
    private _apiGatewayId?;
    get apiGatewayId(): string;
    set apiGatewayId(value: string);
    resetApiGatewayId(): void;
    get apiGatewayIdInput(): string | undefined;
    get createdAt(): string;
    get description(): string;
    get domain(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get id(): string;
    labels(key: string): string | cdktf.IResolvable;
    get logGroupId(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get status(): string;
    get userDomains(): string[];
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
