import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexFunctionScalingPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy#function_id DataYandexFunctionScalingPolicy#function_id}
    */
    readonly functionId: string;
    /**
    * policy block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy#policy DataYandexFunctionScalingPolicy#policy}
    */
    readonly policy?: DataYandexFunctionScalingPolicyPolicy[] | cdktf.IResolvable;
}
export interface DataYandexFunctionScalingPolicyPolicy {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy#zone_instances_limit DataYandexFunctionScalingPolicy#zone_instances_limit}
    */
    readonly zoneInstancesLimit?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy#zone_requests_limit DataYandexFunctionScalingPolicy#zone_requests_limit}
    */
    readonly zoneRequestsLimit?: number;
}
export declare function dataYandexFunctionScalingPolicyPolicyToTerraform(struct?: DataYandexFunctionScalingPolicyPolicy | cdktf.IResolvable): any;
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy yandex_function_scaling_policy}
*/
export declare class DataYandexFunctionScalingPolicy extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_function_scaling_policy";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy yandex_function_scaling_policy} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexFunctionScalingPolicyConfig
    */
    constructor(scope: Construct, id: string, config: DataYandexFunctionScalingPolicyConfig);
    private _functionId?;
    get functionId(): string;
    set functionId(value: string);
    get functionIdInput(): string | undefined;
    get id(): string;
    private _policy?;
    get policy(): DataYandexFunctionScalingPolicyPolicy[] | cdktf.IResolvable;
    set policy(value: DataYandexFunctionScalingPolicyPolicy[] | cdktf.IResolvable);
    resetPolicy(): void;
    get policyInput(): cdktf.IResolvable | DataYandexFunctionScalingPolicyPolicy[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
