import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexIamPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
    * binding block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_policy#binding DataYandexIamPolicy#binding}
    */
    readonly binding: DataYandexIamPolicyBinding[] | cdktf.IResolvable;
}
export interface DataYandexIamPolicyBinding {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_policy#members DataYandexIamPolicy#members}
    */
    readonly members: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_policy#role DataYandexIamPolicy#role}
    */
    readonly role: string;
}
export declare function dataYandexIamPolicyBindingToTerraform(struct?: DataYandexIamPolicyBinding | cdktf.IResolvable): any;
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/iam_policy yandex_iam_policy}
*/
export declare class DataYandexIamPolicy extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_iam_policy";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/iam_policy yandex_iam_policy} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexIamPolicyConfig
    */
    constructor(scope: Construct, id: string, config: DataYandexIamPolicyConfig);
    get id(): string;
    get policyData(): string;
    private _binding?;
    get binding(): DataYandexIamPolicyBinding[] | cdktf.IResolvable;
    set binding(value: DataYandexIamPolicyBinding[] | cdktf.IResolvable);
    get bindingInput(): cdktf.IResolvable | DataYandexIamPolicyBinding[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
