import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexVpcNetworkConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_network#folder_id DataYandexVpcNetwork#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_network#name DataYandexVpcNetwork#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_network#network_id DataYandexVpcNetwork#network_id}
    */
    readonly networkId?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/vpc_network yandex_vpc_network}
*/
export declare class DataYandexVpcNetwork extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_vpc_network";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/vpc_network yandex_vpc_network} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexVpcNetworkConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexVpcNetworkConfig);
    get createdAt(): string;
    get defaultSecurityGroupId(): string;
    get description(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get id(): string;
    labels(key: string): string | cdktf.IResolvable;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _networkId?;
    get networkId(): string;
    set networkId(value: string);
    resetNetworkId(): void;
    get networkIdInput(): string | undefined;
    get subnetIds(): string[];
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
