import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface FunctionScalingPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#function_id FunctionScalingPolicy#function_id}
    */
    readonly functionId: string;
    /**
    * policy block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#policy FunctionScalingPolicy#policy}
    */
    readonly policy?: FunctionScalingPolicyPolicy[] | cdktf.IResolvable;
}
export interface FunctionScalingPolicyPolicy {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#tag FunctionScalingPolicy#tag}
    */
    readonly tag: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#zone_instances_limit FunctionScalingPolicy#zone_instances_limit}
    */
    readonly zoneInstancesLimit?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#zone_requests_limit FunctionScalingPolicy#zone_requests_limit}
    */
    readonly zoneRequestsLimit?: number;
}
export declare function functionScalingPolicyPolicyToTerraform(struct?: FunctionScalingPolicyPolicy | cdktf.IResolvable): any;
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy yandex_function_scaling_policy}
*/
export declare class FunctionScalingPolicy extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_function_scaling_policy";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy yandex_function_scaling_policy} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options FunctionScalingPolicyConfig
    */
    constructor(scope: Construct, id: string, config: FunctionScalingPolicyConfig);
    private _functionId?;
    get functionId(): string;
    set functionId(value: string);
    get functionIdInput(): string | undefined;
    get id(): string;
    private _policy?;
    get policy(): FunctionScalingPolicyPolicy[] | cdktf.IResolvable;
    set policy(value: FunctionScalingPolicyPolicy[] | cdktf.IResolvable);
    resetPolicy(): void;
    get policyInput(): cdktf.IResolvable | FunctionScalingPolicyPolicy[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
