import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface IamServiceAccountIamPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_policy#policy_data IamServiceAccountIamPolicy#policy_data}
    */
    readonly policyData: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_policy#service_account_id IamServiceAccountIamPolicy#service_account_id}
    */
    readonly serviceAccountId: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_policy yandex_iam_service_account_iam_policy}
*/
export declare class IamServiceAccountIamPolicy extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_iam_service_account_iam_policy";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_policy yandex_iam_service_account_iam_policy} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options IamServiceAccountIamPolicyConfig
    */
    constructor(scope: Construct, id: string, config: IamServiceAccountIamPolicyConfig);
    get id(): string;
    private _policyData?;
    get policyData(): string;
    set policyData(value: string);
    get policyDataInput(): string | undefined;
    private _serviceAccountId?;
    get serviceAccountId(): string;
    set serviceAccountId(value: string);
    get serviceAccountIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
