import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface IamServiceAccountConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#description IamServiceAccount#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#folder_id IamServiceAccount#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#name IamServiceAccount#name}
    */
    readonly name: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#timeouts IamServiceAccount#timeouts}
    */
    readonly timeouts?: IamServiceAccountTimeouts;
}
export interface IamServiceAccountTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#create IamServiceAccount#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#delete IamServiceAccount#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#update IamServiceAccount#update}
    */
    readonly update?: string;
}
export declare function iamServiceAccountTimeoutsToTerraform(struct?: IamServiceAccountTimeoutsOutputReference | IamServiceAccountTimeouts | cdktf.IResolvable): any;
export declare class IamServiceAccountTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): IamServiceAccountTimeouts | undefined;
    set internalValue(value: IamServiceAccountTimeouts | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account yandex_iam_service_account}
*/
export declare class IamServiceAccount extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_iam_service_account";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account yandex_iam_service_account} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options IamServiceAccountConfig
    */
    constructor(scope: Construct, id: string, config: IamServiceAccountConfig);
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _timeouts;
    get timeouts(): IamServiceAccountTimeoutsOutputReference;
    putTimeouts(value: IamServiceAccountTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): IamServiceAccountTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
