import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface LbTargetGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#description LbTargetGroup#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#folder_id LbTargetGroup#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#labels LbTargetGroup#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#name LbTargetGroup#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#region_id LbTargetGroup#region_id}
    */
    readonly regionId?: string;
    /**
    * target block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#target LbTargetGroup#target}
    */
    readonly target?: LbTargetGroupTarget[] | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#timeouts LbTargetGroup#timeouts}
    */
    readonly timeouts?: LbTargetGroupTimeouts;
}
export interface LbTargetGroupTarget {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#address LbTargetGroup#address}
    */
    readonly address: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#subnet_id LbTargetGroup#subnet_id}
    */
    readonly subnetId: string;
}
export declare function lbTargetGroupTargetToTerraform(struct?: LbTargetGroupTarget | cdktf.IResolvable): any;
export interface LbTargetGroupTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#create LbTargetGroup#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#delete LbTargetGroup#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#update LbTargetGroup#update}
    */
    readonly update?: string;
}
export declare function lbTargetGroupTimeoutsToTerraform(struct?: LbTargetGroupTimeoutsOutputReference | LbTargetGroupTimeouts | cdktf.IResolvable): any;
export declare class LbTargetGroupTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): LbTargetGroupTimeouts | undefined;
    set internalValue(value: LbTargetGroupTimeouts | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group yandex_lb_target_group}
*/
export declare class LbTargetGroup extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_lb_target_group";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group yandex_lb_target_group} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options LbTargetGroupConfig = {}
    */
    constructor(scope: Construct, id: string, config?: LbTargetGroupConfig);
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get id(): string;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _regionId?;
    get regionId(): string;
    set regionId(value: string);
    resetRegionId(): void;
    get regionIdInput(): string | undefined;
    private _target?;
    get target(): LbTargetGroupTarget[] | cdktf.IResolvable;
    set target(value: LbTargetGroupTarget[] | cdktf.IResolvable);
    resetTarget(): void;
    get targetInput(): cdktf.IResolvable | LbTargetGroupTarget[] | undefined;
    private _timeouts;
    get timeouts(): LbTargetGroupTimeoutsOutputReference;
    putTimeouts(value: LbTargetGroupTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): LbTargetGroupTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
