import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface MdbMongodbClusterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#cluster_id MdbMongodbCluster#cluster_id}
    */
    readonly clusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#deletion_protection MdbMongodbCluster#deletion_protection}
    */
    readonly deletionProtection?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#description MdbMongodbCluster#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#environment MdbMongodbCluster#environment}
    */
    readonly environment: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#folder_id MdbMongodbCluster#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#labels MdbMongodbCluster#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#name MdbMongodbCluster#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#network_id MdbMongodbCluster#network_id}
    */
    readonly networkId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#security_group_ids MdbMongodbCluster#security_group_ids}
    */
    readonly securityGroupIds?: string[];
    /**
    * cluster_config block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#cluster_config MdbMongodbCluster#cluster_config}
    */
    readonly clusterConfig: MdbMongodbClusterClusterConfig;
    /**
    * database block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#database MdbMongodbCluster#database}
    */
    readonly database: MdbMongodbClusterDatabase[] | cdktf.IResolvable;
    /**
    * host block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#host MdbMongodbCluster#host}
    */
    readonly host: MdbMongodbClusterHost[] | cdktf.IResolvable;
    /**
    * maintenance_window block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#maintenance_window MdbMongodbCluster#maintenance_window}
    */
    readonly maintenanceWindow?: MdbMongodbClusterMaintenanceWindow;
    /**
    * resources block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#resources MdbMongodbCluster#resources}
    */
    readonly resources: MdbMongodbClusterResources;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#timeouts MdbMongodbCluster#timeouts}
    */
    readonly timeouts?: MdbMongodbClusterTimeouts;
    /**
    * user block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#user MdbMongodbCluster#user}
    */
    readonly user: MdbMongodbClusterUser[] | cdktf.IResolvable;
}
export interface MdbMongodbClusterClusterConfigAccess {
}
export declare function mdbMongodbClusterClusterConfigAccessToTerraform(struct?: MdbMongodbClusterClusterConfigAccessOutputReference | MdbMongodbClusterClusterConfigAccess): any;
export declare class MdbMongodbClusterClusterConfigAccessOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbMongodbClusterClusterConfigAccess | undefined;
    set internalValue(value: MdbMongodbClusterClusterConfigAccess | undefined);
    get dataLens(): cdktf.IResolvable;
}
export interface MdbMongodbClusterClusterConfigBackupWindowStart {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#hours MdbMongodbCluster#hours}
    */
    readonly hours?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#minutes MdbMongodbCluster#minutes}
    */
    readonly minutes?: number;
}
export declare function mdbMongodbClusterClusterConfigBackupWindowStartToTerraform(struct?: MdbMongodbClusterClusterConfigBackupWindowStartOutputReference | MdbMongodbClusterClusterConfigBackupWindowStart): any;
export declare class MdbMongodbClusterClusterConfigBackupWindowStartOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbMongodbClusterClusterConfigBackupWindowStart | undefined;
    set internalValue(value: MdbMongodbClusterClusterConfigBackupWindowStart | undefined);
    private _hours?;
    get hours(): number;
    set hours(value: number);
    resetHours(): void;
    get hoursInput(): number | undefined;
    private _minutes?;
    get minutes(): number;
    set minutes(value: number);
    resetMinutes(): void;
    get minutesInput(): number | undefined;
}
export interface MdbMongodbClusterClusterConfig {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#feature_compatibility_version MdbMongodbCluster#feature_compatibility_version}
    */
    readonly featureCompatibilityVersion?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#version MdbMongodbCluster#version}
    */
    readonly version: string;
    /**
    * access block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#access MdbMongodbCluster#access}
    */
    readonly access?: MdbMongodbClusterClusterConfigAccess;
    /**
    * backup_window_start block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#backup_window_start MdbMongodbCluster#backup_window_start}
    */
    readonly backupWindowStart?: MdbMongodbClusterClusterConfigBackupWindowStart;
}
export declare function mdbMongodbClusterClusterConfigToTerraform(struct?: MdbMongodbClusterClusterConfigOutputReference | MdbMongodbClusterClusterConfig): any;
export declare class MdbMongodbClusterClusterConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbMongodbClusterClusterConfig | undefined;
    set internalValue(value: MdbMongodbClusterClusterConfig | undefined);
    private _featureCompatibilityVersion?;
    get featureCompatibilityVersion(): string;
    set featureCompatibilityVersion(value: string);
    resetFeatureCompatibilityVersion(): void;
    get featureCompatibilityVersionInput(): string | undefined;
    private _version?;
    get version(): string;
    set version(value: string);
    get versionInput(): string | undefined;
    private _access;
    get access(): MdbMongodbClusterClusterConfigAccessOutputReference;
    putAccess(value: MdbMongodbClusterClusterConfigAccess): void;
    resetAccess(): void;
    get accessInput(): MdbMongodbClusterClusterConfigAccess | undefined;
    private _backupWindowStart;
    get backupWindowStart(): MdbMongodbClusterClusterConfigBackupWindowStartOutputReference;
    putBackupWindowStart(value: MdbMongodbClusterClusterConfigBackupWindowStart): void;
    resetBackupWindowStart(): void;
    get backupWindowStartInput(): MdbMongodbClusterClusterConfigBackupWindowStart | undefined;
}
export interface MdbMongodbClusterDatabase {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#name MdbMongodbCluster#name}
    */
    readonly name: string;
}
export declare function mdbMongodbClusterDatabaseToTerraform(struct?: MdbMongodbClusterDatabase | cdktf.IResolvable): any;
export interface MdbMongodbClusterHost {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#assign_public_ip MdbMongodbCluster#assign_public_ip}
    */
    readonly assignPublicIp?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#role MdbMongodbCluster#role}
    */
    readonly role?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#shard_name MdbMongodbCluster#shard_name}
    */
    readonly shardName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#subnet_id MdbMongodbCluster#subnet_id}
    */
    readonly subnetId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#type MdbMongodbCluster#type}
    */
    readonly type?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#zone_id MdbMongodbCluster#zone_id}
    */
    readonly zoneId: string;
}
export declare function mdbMongodbClusterHostToTerraform(struct?: MdbMongodbClusterHost | cdktf.IResolvable): any;
export interface MdbMongodbClusterMaintenanceWindow {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#day MdbMongodbCluster#day}
    */
    readonly day?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#hour MdbMongodbCluster#hour}
    */
    readonly hour?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#type MdbMongodbCluster#type}
    */
    readonly type: string;
}
export declare function mdbMongodbClusterMaintenanceWindowToTerraform(struct?: MdbMongodbClusterMaintenanceWindowOutputReference | MdbMongodbClusterMaintenanceWindow): any;
export declare class MdbMongodbClusterMaintenanceWindowOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbMongodbClusterMaintenanceWindow | undefined;
    set internalValue(value: MdbMongodbClusterMaintenanceWindow | undefined);
    private _day?;
    get day(): string;
    set day(value: string);
    resetDay(): void;
    get dayInput(): string | undefined;
    private _hour?;
    get hour(): number;
    set hour(value: number);
    resetHour(): void;
    get hourInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export interface MdbMongodbClusterResources {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#disk_size MdbMongodbCluster#disk_size}
    */
    readonly diskSize: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#disk_type_id MdbMongodbCluster#disk_type_id}
    */
    readonly diskTypeId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#resource_preset_id MdbMongodbCluster#resource_preset_id}
    */
    readonly resourcePresetId: string;
}
export declare function mdbMongodbClusterResourcesToTerraform(struct?: MdbMongodbClusterResourcesOutputReference | MdbMongodbClusterResources): any;
export declare class MdbMongodbClusterResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbMongodbClusterResources | undefined;
    set internalValue(value: MdbMongodbClusterResources | undefined);
    private _diskSize?;
    get diskSize(): number;
    set diskSize(value: number);
    get diskSizeInput(): number | undefined;
    private _diskTypeId?;
    get diskTypeId(): string;
    set diskTypeId(value: string);
    get diskTypeIdInput(): string | undefined;
    private _resourcePresetId?;
    get resourcePresetId(): string;
    set resourcePresetId(value: string);
    get resourcePresetIdInput(): string | undefined;
}
export interface MdbMongodbClusterTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#create MdbMongodbCluster#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#delete MdbMongodbCluster#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#update MdbMongodbCluster#update}
    */
    readonly update?: string;
}
export declare function mdbMongodbClusterTimeoutsToTerraform(struct?: MdbMongodbClusterTimeoutsOutputReference | MdbMongodbClusterTimeouts | cdktf.IResolvable): any;
export declare class MdbMongodbClusterTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbMongodbClusterTimeouts | undefined;
    set internalValue(value: MdbMongodbClusterTimeouts | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
export interface MdbMongodbClusterUserPermission {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#database_name MdbMongodbCluster#database_name}
    */
    readonly databaseName: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#roles MdbMongodbCluster#roles}
    */
    readonly roles?: string[];
}
export declare function mdbMongodbClusterUserPermissionToTerraform(struct?: MdbMongodbClusterUserPermission | cdktf.IResolvable): any;
export interface MdbMongodbClusterUser {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#name MdbMongodbCluster#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#password MdbMongodbCluster#password}
    */
    readonly password: string;
    /**
    * permission block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#permission MdbMongodbCluster#permission}
    */
    readonly permission?: MdbMongodbClusterUserPermission[] | cdktf.IResolvable;
}
export declare function mdbMongodbClusterUserToTerraform(struct?: MdbMongodbClusterUser | cdktf.IResolvable): any;
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster yandex_mdb_mongodb_cluster}
*/
export declare class MdbMongodbCluster extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_mdb_mongodb_cluster";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster yandex_mdb_mongodb_cluster} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options MdbMongodbClusterConfig
    */
    constructor(scope: Construct, id: string, config: MdbMongodbClusterConfig);
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    resetClusterId(): void;
    get clusterIdInput(): string | undefined;
    get createdAt(): string;
    private _deletionProtection?;
    get deletionProtection(): boolean | cdktf.IResolvable;
    set deletionProtection(value: boolean | cdktf.IResolvable);
    resetDeletionProtection(): void;
    get deletionProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _environment?;
    get environment(): string;
    set environment(value: string);
    get environmentInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get health(): string;
    get id(): string;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _networkId?;
    get networkId(): string;
    set networkId(value: string);
    get networkIdInput(): string | undefined;
    private _securityGroupIds?;
    get securityGroupIds(): string[];
    set securityGroupIds(value: string[]);
    resetSecurityGroupIds(): void;
    get securityGroupIdsInput(): string[] | undefined;
    get sharded(): cdktf.IResolvable;
    get status(): string;
    private _clusterConfig;
    get clusterConfig(): MdbMongodbClusterClusterConfigOutputReference;
    putClusterConfig(value: MdbMongodbClusterClusterConfig): void;
    get clusterConfigInput(): MdbMongodbClusterClusterConfig | undefined;
    private _database?;
    get database(): MdbMongodbClusterDatabase[] | cdktf.IResolvable;
    set database(value: MdbMongodbClusterDatabase[] | cdktf.IResolvable);
    get databaseInput(): cdktf.IResolvable | MdbMongodbClusterDatabase[] | undefined;
    private _host?;
    get host(): MdbMongodbClusterHost[] | cdktf.IResolvable;
    set host(value: MdbMongodbClusterHost[] | cdktf.IResolvable);
    get hostInput(): cdktf.IResolvable | MdbMongodbClusterHost[] | undefined;
    private _maintenanceWindow;
    get maintenanceWindow(): MdbMongodbClusterMaintenanceWindowOutputReference;
    putMaintenanceWindow(value: MdbMongodbClusterMaintenanceWindow): void;
    resetMaintenanceWindow(): void;
    get maintenanceWindowInput(): MdbMongodbClusterMaintenanceWindow | undefined;
    private _resources;
    get resources(): MdbMongodbClusterResourcesOutputReference;
    putResources(value: MdbMongodbClusterResources): void;
    get resourcesInput(): MdbMongodbClusterResources | undefined;
    private _timeouts;
    get timeouts(): MdbMongodbClusterTimeoutsOutputReference;
    putTimeouts(value: MdbMongodbClusterTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): MdbMongodbClusterTimeouts | undefined;
    private _user?;
    get user(): MdbMongodbClusterUser[] | cdktf.IResolvable;
    set user(value: MdbMongodbClusterUser[] | cdktf.IResolvable);
    get userInput(): cdktf.IResolvable | MdbMongodbClusterUser[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
